 #!/usr/bin/perl -w


  use warnings;
  use strict;
  use sub_ms_group;

print "\n****************************************************\nMicroFamily Vesion 1\n15 July 2006\nEmese Meglecz\n";
print 'meglecz@up.univ-mrs.fr';
print "\n****************************************************\n";

my $reply = '';
my $folder = 'datatemp';
my $outfolder = 'temp';
#my $min_repeat = 4;
#my $min_repeat_single = 8;
#my $Evector = '1E-3';
#my $Eblast = '1E-40';
#my $red_limit = 0.95;
#my $path_blast = '/usr/local/bin/blast-2.2.13/bin/';
#my $path_clustal = '/usr/local/bin/clustalw1.83/';

open(SET, 'set_file');
my @setings = <SET>;


my $min_repeat = $setings[0];
chomp $min_repeat;
my $min_repeat_single = $setings[1];
chomp $min_repeat_single;
my $Evector = $setings[2];
chomp $Evector;
my $Eblast = $setings[3];
chomp $Eblast;
my $red_limit = $setings[4];
chomp $red_limit;
my $path_blast = $setings[5];
chomp $path_blast;
my $path_clustal = $setings[6];
chomp $path_clustal;

open (SETOUT, '>set_file');

while ( not ($reply eq "\n"))
{
    print "\nA: Minimum number of repeats for 2-3-4-5-6-bp motifs:  $min_repeat\nB: Minimum number of repeats for single-bp motifs:     $min_repeat_single\nC: e value for vector search:                          $Evector\nD: e value for BLASTing sequences againts each other:  $Eblast\nE: lowest identity for redundant sequences:            $red_limit\nF: pathway to BLAST:                                   $path_blast\nG: pathway to CLUSTAL:                                 $path_clustal\n\nPress Enter if all of the above settings are correct, or the appropriate capital letter if you want to change the settings\n";

    $reply = <STDIN>;

    if ($reply eq "\n")
    {
	print SETOUT "$min_repeat\n$min_repeat_single\n$Evector\n$Eblast\n$red_limit\n$path_blast\n$path_clustal\n";
	next;
    }
    else
    {
	chomp $reply;
	if ($reply eq 'A' or $reply eq 'a' )
	{
	    print "Enter the minimum number of repeats for 2-3-4-5-6-bp microtellite motifs\n";
	    $min_repeat = <STDIN>;
	    chomp $min_repeat;
	}
	if ($reply eq 'B' or $reply eq 'b' )
	{
	    print "Enter the minimum number of repeats for single-bp microtellite motifs\n";
	    $min_repeat_single = <STDIN>;
	    chomp $min_repeat_single;
	}
	if ($reply eq 'C' or $reply eq 'c')
	{
	    print "Enter the e value for vector search\n";
	    $Evector = <STDIN>;
	    chomp $Evector;
	}
	if ($reply eq 'D' or $reply eq 'd')
	{
	    print "Enter e value for BLASTing sequences againts each other\n";
	    $Eblast = <STDIN>;
	    chomp $Eblast;
	}
	if ($reply eq 'E' or $reply eq 'e')
	{
	    print "Enter the lowest idetity value for redundant sequences\n";
	    $red_limit = <STDIN>;
	    chomp $red_limit;
	}
	if ($reply eq 'F' or $reply eq 'f')
	{
	    print "Enter the pathway to BLAST executables\n";
	    $path_blast = <STDIN>;
	    chomp $path_blast;
	}
	if ($reply eq 'G' or $reply eq 'g')
	{
	    print "Enter the pathway to CLUSTAL executables\n";
	    $path_clustal = <STDIN>;
	    chomp $path_clustal;
	}
    }

}

lance_cl($folder, $outfolder, $min_repeat, $min_repeat_single, $Evector, $path_blast);

lance_blast($folder, $outfolder, $Eblast, $red_limit, $path_blast, $path_clustal);

exit;

###################################################################
sub lance_cl
{

    my ($folder, $outfolder, $min_repeat, $min_repeat_single, $Evector, $path_blast) = @_;

 unless (opendir(OUTFOLDER, $outfolder))
{
    print "Cannot access to folder $outfolder\n";
    exit;
}
closedir(OUTFOLDER);

  unless ( opendir(FOLDER, $folder) )
  {
      print "Cannot access to folder $folder\n";
      exit;
  }
my @filenames = grep ( !/^\.\.?$/, readdir(FOLDER) );

  if (scalar@filenames == 0)
  {
      print "datatemp folder is empty!\n\n";
      exit;
  }


  foreach my $filename (@filenames)
  {
     $filename = $folder.'/'.$filename; 
  }
 
closedir(FOLDER);

 
  foreach my $filename (@filenames)
  {
     print "\nInput file: $filename\n\n";
     my $clean = 'perl clean.pl '.$filename.' '.$outfolder.' '.$min_repeat.' '.$min_repeat_single.' '.$Evector.' '.$path_blast;
     system $clean;

  }

}

###################################################################

sub lance_blast

{
    my ($folder, $outfolder, $Eblast, $red_limit, $path_blast, $path_clustal) = @_;

 unless (opendir(OUTFOLDER, $outfolder))
{
    print "Cannot access to folder $outfolder\n";
    exit;
}

my @filenames = grep ( !/^\.\.?$/, readdir(OUTFOLDER) );
my @filenames1 = ();

  foreach my $filename (@filenames)
  {
      if ($filename =~ /\.WOV/)
      {
	  $filename = $outfolder.'/'.$filename; 
	  push (@filenames1, $filename);
      }
  }
 
closedir(FOLDER);

print "\n\nGrouping sequences. This step might take a few minutes. Please, wait!\n";
  foreach my $filename (@filenames1)
  {

     my $class = 'perl class.pl '.$filename.' '.$outfolder.' '.$Eblast.' '.$red_limit.' '.$path_blast.' '.$path_clustal;
     system $class;

  }



}
